import { world, system } from "@minecraft/server";

world.afterEvents.itemUse.subscribe(ev => { //アイテムを使ったら
    const { itemStack, source } = ev;
    if (itemStack.typeId == "tunekeshi:last_prism") {
        source.addTag("beam"); //タグ追加
    }
});

world.afterEvents.itemStopUse.subscribe(ev => { //アイテムの使用をやめたら
    const { itemStack, source } = ev;
    if (itemStack.typeId == "tunekeshi:last_prism") {
        source.removeTag("beam"); //タグ削除
    }
});

world.afterEvents.entityDie.subscribe((ev) => {
  const { deadEntity:entity }  = ev;
  if ( entity.typeId == "minecraft:player" && entity.hasTag("beam")) {
    player.removeTag("beam");
  }
});

system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        if (!player.hasTag("beam")) return; // tag beamもってないときは処理を中止
        const sourceHeadLocation = player.getHeadLocation(); //プレイヤーの頭の位置
        const sourceViewDirection = player.getViewDirection(); //プレイヤーの向いてる方向
        for (let i = 2; i < 23; i++) { //for loop(ググって)
            const spawnLocation = {
                x: sourceHeadLocation.x + sourceViewDirection.x*i,
                y: sourceHeadLocation.y + sourceViewDirection.y*i,
                z: sourceHeadLocation.z + sourceViewDirection.z*i
            }; //ここはいじらなくていい
            player.dimension.spawnParticle("tunekeshi:beam", spawnLocation); //パーティクル召喚
            for (const entity of player.dimension.getEntities({location: spawnLocation, maxDistance: 2,excludeTags:["beam"],excludeTypes:["minecraft:item","minecraft:xp_orb"]})) {
                entity.applyDamage(1,{cause: "suicide", damagingEntity: player}); //ダメ０－字を与える
            }
        }
    }
});